<template>
        <div class="searching-container"
         :style="styles"
        >
          <div class="searching-block">
            <nuxt-icon
             class="icon-search"
             name="IconSearch"
             filled
            />
            <input
             class="searching-row"
             type="text"
             placeholder="Введите фразу для поиска"
             name="searchInput"
             id="searchInput"
             v-model="searchInputValue"
             @input="(event) => getInputValue(event)"
             @keydown.down.prevent="keyDownHandler"
             @keydown.up.prevent="keyUpHandler"
             @keydown.enter.prevent="pressEnterButton"
            >
              <nuxt-icon
               class="icon-clear"
               v-if="searchInputValue"
               @click="clearInputValue"
               name="IconClose"
               filled
              />
          </div>
          <BaseButtonComponent
           class="searching-btn"
           :bg-color="'#E5722A'"
           :btn-txt="'Найти'"
           :txt-color="'#FFFFFF'"
           @click="searchHandler"
          />
        </div>
        <BaseDropdownComponent
         v-if="searchInputValue && (tipsArr.length || documentsArr.length)"
         :dropdown-width="dropdownParams.width"
         :arrow="dropdownParams.arrow"
         :dropdown-position="dropdownParams.position"
         v-model:dropDownIsVisible="dropDownIsVisible"
        >
          <template v-slot:drop_content >
            <div class="dropdown-block">
              <ul class="dropdown-content" :style="{ height: 'fit-content' }">
                <li
                 ref="dropdownItem"
                 class="dropdown-item"
                 :class="{ selected: dropdownItemIndex === index }"
                 v-for="(item, index) in tipsArr"
                 :key="index"
                 @click.prevent="selectValue(item)"
                >
                  <nuxt-icon
                   class="icon-search"
                   name="IconSearch"
                   filled
                  />
                    {{ item.q }}
                  </li>
              </ul>
              <h3 class="dropdown-header" v-if="documentsArr.length">Наиболее подходящие документы:</h3>
              <ul class="dropdown-content documents" :style="{ height: 'fit-content' }">
                <li
                 ref="dropdownItem"
                 class="dropdown-item"
                 :class="{ selected: dropdownItemIndex - tipsArr.length  === index }"
                 v-for="(item, index) in documentsArr"
                 :key="index"
                 @click.prevent="selectValue(item)"
                >
                  <a :href="item.link" class="dropdown-item_lk">
                    <nuxt-icon
                     class="icon-file"
                     name="IconFile"
                     filled
                    />
                    <span>{{ item.name }}</span>
                  </a>
                </li>
              </ul>
            </div>
          </template>
        </BaseDropdownComponent>
</template>

<script setup>
import { computed, ref } from "vue";
const router = useRouter();
const emit = defineEmits(["update:searchInputValue"]);
const props = defineProps({
  width: {
    type: String,
    default: '50%',
  },
  height: {
    type: String,
    default: '3rem',
  },
  colors: {
    type: Object,
    default: () => {},
  },
  dropdownParams: {
    type: Object,
    default: () => {}
  }
});
defineOptions({
  inheritAttrs: false,
});

const { data: info } = await useFetch('/api/tips', {
  transform: (_info) => _info.data
});
const tipsArr = ref([]);
const documentsArr = ref([]);
const searchInputValue = ref('');
const dropDownIsVisible = ref(false);
const dropdownItem = ref(null);
const dropdownSelectedValue = ref(null);
const dropdownItemIndex = ref(-1);
const styles = computed(() => {
      return {
        '--input-txt-color': props.colors.txt,
        '--input-background-color': props.colors.inptBgr,
        '--main-background-color': props.colors.mainBgr,
        width: props.width,
        height: props.height
      };
});

const getInputValue = (event) => {
  emit('update:searchInputValue', event.target.value)
  dropDownIsVisible.value = true;
  let responseData = toRaw(info.value).groups;
  documentsArr.value = [];
  tipsArr.value = [];

  documentsArr.value = responseData.documents.filter((doc) => 
    doc.name.toLocaleLowerCase().includes(searchInputValue.value.toLocaleLowerCase())
  );
  tipsArr.value = responseData.tips.filter((tip) => 
    tip.q.toLocaleLowerCase().includes(searchInputValue.value.toLocaleLowerCase())
  );
}

const keyDownHandler = () => {
  if (dropdownItemIndex.value < dropdownItem.value.length-1) dropdownItemIndex.value++;
  else dropdownItemIndex.value = 0;
  dropdownItem.value[dropdownItemIndex.value].scrollIntoView({
    block: "center",
    behavior: "smooth",
  });
  dropdownSelectedValue.value = dropdownItem.value[dropdownItemIndex.value];
  searchInputValue.value = dropdownItem.value[dropdownItemIndex.value].innerText;
};
const keyUpHandler = () => {
  if (dropdownItemIndex.value > 0) dropdownItemIndex.value--;
  else dropdownItemIndex.value = dropdownItem.value.length-1;
  dropdownItem.value[dropdownItemIndex.value].scrollIntoView({
    block: "center",
    behavior: "smooth",
  });
  searchInputValue.value = dropdownItem.value[dropdownItemIndex.value].innerText;
};

const selectValue = (item) => {
  if (item.hasOwnProperty('name')) searchInputValue.value = item.name;
  else {
    searchInputValue.value = item.q;
    router.push(`/search?q=${searchInputValue.value}`);
  }
  dropDownIsVisible.value = false;
};

const pressEnterButton = () => {
  if (document.querySelector('.selected a')) document.querySelector('.selected a').click();
  else {
    router.push(`/search?q=${searchInputValue.value}`);
    dropDownIsVisible.value = false;
  };
};

const clearInputValue = () => {
  searchInputValue.value = '';
}
const searchHandler = () => {
  router.push(`/search?q=${searchInputValue.value}`);
  dropDownIsVisible.value = false;
}
</script>

<style lang="sass">
@import '/assets/styles/default.sass'
@import '/assets/styles/_variables.sass'
.searching
  &-container
    background: var(--main-background-color)
    display: flex
    justify-content: flex-start
    align-items: center
    width: 50%
    padding: 0 .5rem
    border-radius: 5px
    position: relative
    color: #2E353F
  &-block
    width: calc( 100% - 7rem )
    height: 3rem
    display: flex
    align-items: center
  &-row
    background: var(--input-background-color)
    color: var(--input-txt-color)
    width: 100%
    height: 2rem
    border: transparent
    border-radius: inherit
    outline: none
.icon
    &-search
        svg
            fill: #B3B3B3
            width: $fz * 1.7
            height: $fz * 1.7
            margin-bottom: 0
    &-clear
        margin-right: 1rem
        cursor: pointer
        svg
            fill: var(--input-txt-color)
            width: $fz
            height: $fz
.dropdown
    position: relative
    &-block
        height: 20rem
        overflow-x: auto
        scroll-behavior: smooth
        scrollbar-color: $lightgrey transparent
        scrollbar-width: 8px
        &::-webkit-scrollbar
            background-color:  transparent
            width: 6px
        &::-webkit-scrollbar-thumb
            border-radius: 4px
            min-height: 40px
            background-color: $lightgrey
            border: 1px solid $darkgrey
    &-content
        margin: 0
        width: 100%
        height: 5rem
        position: relative
        z-index: 9
        background: $white
        border-bottom: 1px solid #F6F6F6
        .icon
            &-search
                svg
                    width: $fz * 1.4
                    height: $fz * 1.4
            &-file
                svg
                    fill: #B3B3B3
                    width: $fz * 2
                    height: $fz * 2
    &-item
        position: relative
        list-style: none
        margin: .25rem 0
        text-align: left
        display: flex
        align-items: center
        gap: .5rem
        padding: .5rem
        color: black
        &:hover
            cursor: pointer
            background: $lightgrey
        &_lk
            text-decoration: none
            display: flex
            align-items: center
            gap: .5rem
            &:hover
                text-decoration: underline
            &:before
                content: ''
                position: absolute
                top: 0
                left: 0
                width: 100%
                height: 100%
    &-header
        margin: 1rem 0
        padding: 0 .5rem
        color: black
.documents
    .dropdown
        &-item
            border-top: 1px solid #F6F6F6
.selected
    background: $lightgrey

</style>